=== debian/changelog ===
boost1.65.1 (1.65.1+dfsg-0ubuntu5) bionic; urgency=medium

  * Fixup runtime dependency for libboost-numpy, thanks <ricotz>
    for the ping!

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 06 Mar 2018 11:21:23 +0100

boost1.65.1 (1.65.1+dfsg-0ubuntu4) bionic; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 07 Nov 2017 08:51:57 +0000

boost1.65.1 (1.65.1+dfsg-0ubuntu2) bionic; urgency=medium

  * coroutine2 is no longer an excludable library. Adjust debian/rules.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 26 Oct 2017 10:18:44 +0100

boost1.65.1 (1.65.1+dfsg-0ubuntu1) bionic; urgency=medium

  [ Steve M. Robbins ]
  * New upstream.
  * Remove "Force use g++-6"
  * patches/chrono-duration.patch: Remove.  Obsoleted by upstream changes.
  * New package for Python.NumPy.  Closes: #853734.
  * New packages for Boost.Container, Boost.Stacktrace.

  [ Dimitri John Ledkov ]
  * Fixup py3 suffixes and symlinks.
  * In asciidoctor docs, do not use external webfonts.
  * In doxygen docs, use local mathjax library.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 25 Oct 2017 15:27:28 +0100

boost1.63 (1.63.0+dfsg-1) unstable; urgency=medium

  * New upstream.

 -- Steve M. Robbins <smr@debian.org>  Wed, 28 Dec 2016 20:28:31 -0600

boost1.62 (1.62.0+dfsg-4) unstable; urgency=medium

  * New patch upstream-add-degree-reverse_graph.patch.

 -- Steve M. Robbins <smr@debian.org>  Sat, 12 Nov 2016 12:46:50 -0600

boost1.62 (1.62.0+dfsg-3) unstable; urgency=high

  * Build Boost.Python 2 & 3 bindings in separate builddirs. Closes: #842927

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 07 Nov 2016 18:44:37 +0000

boost1.62 (1.62.0+dfsg-2) unstable; urgency=medium

  * Limit boost-fiber packages to architectures it is built on.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 20 Oct 2016 08:36:55 +0100

boost1.62 (1.62.0+dfsg-1) unstable; urgency=medium

  * New upstream 1.62.
  * Add packages for Boost.Fiber.
  * Drop package libboost1.62-dbg in favour of using automatic debug
    package generation.
  * Refresh patches.  Drop add-missing-list-include.patch -- applied upstream.

 -- Steve M. Robbins <smr@debian.org>  Sun, 16 Oct 2016 01:55:19 -0500

boost1.61 (1.61.0+dfsg-3) unstable; urgency=medium

  [ Dimitri John Ledkov ]
  * Actually bump standards version.

  [ Steve M. Robbins ]
  * Install /usr/bin/b2, the canonical name of bjam.  Closes: #831431.
  * libboost-iostreams1.61.0: remove Priority Important.  Closes: #829301.

 -- Steve M. Robbins <smr@debian.org>  Sat, 15 Oct 2016 10:59:14 -0500

boost1.61 (1.61.0+dfsg-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Upload to unstable.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Wed, 03 Aug 2016 21:10:58 +0200

boost1.61 (1.61.0+dfsg-2) experimental; urgency=high

  * Use DEB_HOST_GNU_TYPE for the compiler, because DEB_HOST_MULTIARCH is
    a lie - i386 port doesn't really exist, nor provides/uses i386
    compiler. Fixes FTBFS on i386.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 03 Aug 2016 03:21:52 +0100

boost1.61 (1.61.0+dfsg-1) experimental; urgency=medium

  * New upstream release
  * Drop upstream cherrypicked patches, no longer needed
  * Update example files and sort them
  * Force use g++-6
  * Add python3:Depends for python packages (pacify dh_python3 warnings)
  * Drop python2.5 depends
  * Require icu 57 or better

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 01 Aug 2016 14:05:10 +0100

boost1.60 (1.60.0+dfsg-6) unstable; urgency=medium

  * patches/fix-ebo_functor_holder.patch: New. Compile fix for copy
    constructor (thanks, Graham Inggs).  Closes: #824021.

  * patches/add-missing-list-include.patch: New.  Add missing <list>
    include (thanks, Graham Inggs).  Closes: #824022.

 -- Steve M. Robbins <smr@debian.org>  Sun, 15 May 2016 23:38:50 -0500

boost1.60 (1.60.0+dfsg-5) unstable; urgency=medium

  [ Dimitri John Ledkov ]
  * Cherrypick upstream graph patch to fix ftbfs when adjacency_matrix.hpp
    template is used. Fixes FTBFS of sfcgal.

  [ Steve M. Robbins ]
  * patches/fix-auto-pointer-registration.patch: New.  Fixes auto-pointer
    registration in Boost.Python, affecting yade.  Closes: #823210.

 -- Steve M. Robbins <smr@debian.org>  Sat, 07 May 2016 22:23:17 -0500

boost1.60 (1.60.0+dfsg-4) unstable; urgency=medium

  * Fully enable context and coroutine on arm64, as it is available there.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 22 Apr 2016 14:52:41 +0100

boost1.60 (1.60.0+dfsg-3) unstable; urgency=medium

  * Drop all the without/just mpi build logic, Ubuntu no longer needs it,
    as Archive Reorg is complete and packages in main can now build-depend
    on packages in universe (e.g. mpi). Boost can now be in-sync between
    Debian and Ubuntu.
  * Drop context/coroutine from arm64, not build there.
  * Arch qualify all context/coroutine dependencies such that we don't
    declare dependencies on non-existant packages.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 22 Apr 2016 11:43:50 +0100

boost1.60 (1.60.0+dfsg-2) unstable; urgency=medium

  * Use --without-coroutine2 on arches that can't build context or
    coroutine; otherwise the build system tries to build context
    anyway.  Upstream bug https://svn.boost.org/trac/boost/ticket/9453

  * patches/fenv.patch: New.  Fix build failure on architectures
    (e.g. power pc) where feclearexcept() and friends may be a macro.

 -- Steve M. Robbins <smr@debian.org>  Sat, 16 Apr 2016 16:12:21 -0500

boost1.60 (1.60.0+dfsg-1) unstable; urgency=medium

  * New upstream version.  Closes: #809228.

  * control: Updated for 1.60 using update-control.py.
    - Add packages for type-erasure.
    - Restrict arch for context, coroutine, to avoid empty packages.
      Closes: #808626
    - Don't ship doc files.  Too many fail lintian checks.

  * copyright: Exclude *.js in repacked tarball to satisfy the pedants.

